/*
 * Micro-X -- an X server for DOS
 * Copyright (C) 1992 StarNet Communications Corp.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * StarNet Communications Corp.
 * 550 Lakeside Dr. #3
 * Sunnyvale CA 94086 US
 * http://www.starnet.com
 * x-dos@starnet.com
 */
/*************************************************************************/
/*  TCP states
*     each connection has an associated state in the connection flow.
*     the order of the states now matters, those less than a certain
*     number are the "inactive" states.
*/
#define SCLOSED 1
#define SLISTEN 2
#define SSYNRS	3	/* SSYNR from SSYNS */
#define SSYNR   4
#define SSYNS	5
#define SEST	6
#define SFW1	7
#define SFW2	8
#define SCLOSING 9
#define SCWAIT	10
#define SLAST	11
#define STWAIT	12

#define MINRTO	18		/* actually 18.2 ticks per second */
#define MAXRTO	1820		/* this makes MAXRTO 100 seconds */
#define MSS_SMALL	(512-40)
#define WAITTIME 546		/* time to wait in TIME_WAIT state (30 secs) */
#define TSENDSIZE 1024		/* MSS */
#define SLIPSENDSIZE 768	/* MSS if we are running SLIP */
#define MAXRESENDS	10
