# Micro-X - X server for DOS
# Copyright (C) 1994 StarNet Communications Corp.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
# 
# StarNet Communications Corp.
# 550 Lakeside Dr. #3
# Sunnyvale CA 94086 US
# http://www.starnet.com
# x-dos@starnet.com

# You caught this file in a transition:  The previous version of X-DOS used
# OS/386 from Ergo Computing.  The current uses DOS/4GW, which is a subset
# of DOS/4G from Rational Systems.  DOS/4G is included with WATCOM C/386.

#.SUFFIXES:	.exp
#.SUFFIXES:	.zip

COMMON = dix\dix.lib os\msdos\os.lib ddx\ibm\common\common.lib ddx\mi\mi.lib
L_COMMON = dix\dix,os\msdos\os,ddx\ibm\common\common,ddx\mi\mi
SVGA = ddx\ibm\svga\svga.lib
EGA = ddx\ibm\ega\ega.lib
VGA = ddx\ibm\vga\vga.lib
I8 = ddx\ibm\8514\i8.lib

CONFIG = ..\net\config\config.obj

# tcp.lib in next line
NCSA = os\starnet\starnet.lib ..\net\tcp\tcp.lib
L_NCSA = os\starnet\starnet,..\net\tcp\tcp
GENERIC = os\generic\generic.lib ..\net\generic\generic.lib
L_GENERIC = os\generic\generic,..\net\generic\generic
PMLIBS = $(COMMON) $(NCSA) $(EGA) $(CONFIG)
PCLIBS = $(COMMON) $(NCSA) $(SVGA) $(CONFIG)
GCLIBS = $(COMMON) $(GENERIC) $(SVGA)
GMLIBS = $(COMMON) $(GENERIC) $(EGA)

BIND=c:\os386\bind\bind
KERNEL=c:\os386\os386.exe
LOADER=glue\real\load.exe

LINK=wlink

OBJS   = dix\main.obj ..\fonts\mkfontdi\fontdir.obj ddx\snf\snffonts.obj
L_OBJS = dix\main,    ..\fonts\mkfontdi\fontdir,    ddx\snf\snffonts

all: x3c.exe x3m.exe x3cs.exe x3ms.exe

#.exp.exe: $*.exp $(LOADER)
#	$(BIND) -o $*.exe -k $(KERNEL) -i $*.exp -l $(LOADER)
#	..\..\serial\site $*.exe 198.211.81.0
#	..\..\serial\serial $*.exe 0
#
#x3cs.exe: $(LOADER)
#x3ms.exe: $(LOADER)

x3ms.exe: $(OBJS) $(PMLIBS) x3ms.lnk
	$(LINK) @x3ms

x3cs.exe: $(OBJS) $(PCLIBS) x3cs.lnk
	$(LINK) @x3cs

x3m.exe: $(OBJS) $(GMLIBS) x3m.lnk
	$(LINK) @x3m

x3c.exe: $(OBJS) $(GCLIBS) x3c.lnk
	$(LINK) @x3c

#fontdir.obj: ..\fonts\mkfontdi\fontdir.obj
#	copy ..\fonts\mkfontdi\fontdir.obj fontdir.obj

#x3ms.lnk: makefile
#	echo system ergo > x3ms.lnk
#	echo name x3ms >> x3ms.lnk
#	echo option map >> x3ms.lnk
#	echo option stack=20k >> x3ms.lnk
#	echo option caseexact >> x3ms.lnk
#	echo option dosseg >> x3ms.lnk
#	echo file $(L_OBJS) >> x3ms.lnk
#	echo file $(CONFIG) >> x3ms.lnk
#	echo library $(L_COMMON) >> x3ms.lnk
#	echo library $(EGA) >> x3ms.lnk
#	echo library $(L_NCSA) >> x3ms.lnk
#
#x3cs.lnk: makefile
#	echo system ergo > x3cs.lnk
#	echo name x3cs >> x3cs.lnk
#	echo option map >> x3cs.lnk
#	echo option stack=20k >> x3cs.lnk
#	echo option caseexact >> x3cs.lnk
#	echo option dosseg >> x3cs.lnk
#	echo file $(L_OBJS) >> x3cs.lnk
#	echo file $(CONFIG) >> x3cs.lnk
#	echo library $(L_COMMON) >> x3cs.lnk
#	echo library $(SVGA) >> x3cs.lnk
#	echo library $(L_NCSA) >> x3cs.lnk

x3c.lnk: makefile
	echo system dos4g > x3c.lnk
	echo name x3c >> x3c.lnk
	echo option map >> x3c.lnk
	echo option stack=20k >> x3c.lnk
	echo option caseexact >> x3c.lnk
	echo option dosseg >> x3c.lnk
	echo file $(L_OBJS) >> x3c.lnk
	echo library $(L_COMMON) >> x3c.lnk
	echo library $(SVGA) >> x3c.lnk
	echo library $(L_GENERIC) >> x3c.lnk

x3m.lnk: makefile
	echo system dos4g > x3m.lnk
	echo name x3m >> x3m.lnk
	echo option map >> x3m.lnk
	echo option stack=20k >> x3m.lnk
	echo option caseexact >> x3m.lnk
	echo option dosseg >> x3m.lnk
	echo file $(L_OBJS) >> x3m.lnk
	echo library $(L_COMMON) >> x3m.lnk
	echo library $(EGA) >> x3m.lnk
	echo library $(L_GENERIC) >> x3m.lnk

x3ms.lnk: makefile
	echo system dos4g 	   > x3ms.lnk
	echo name x3ms 		  >> x3ms.lnk
	echo option map 	  >> x3ms.lnk
	echo option stack=20k 	  >> x3ms.lnk
	echo option caseexact 	  >> x3ms.lnk
	echo option dosseg 	  >> x3ms.lnk
	echo file $(L_OBJS) 	  >> x3ms.lnk
	echo file $(CONFIG)	  >> x3ms.lnk
	echo library $(L_COMMON)  >> x3ms.lnk
	echo library $(EGA) 	  >> x3ms.lnk
	echo library $(L_NCSA)    >> x3ms.lnk

x3cs.lnk: makefile
	echo system dos4g 	   > x3cs.lnk
	echo name x3cs 		  >> x3cs.lnk
	echo option map 	  >> x3cs.lnk
	echo option stack=20k 	  >> x3cs.lnk
	echo option caseexact 	  >> x3cs.lnk
	echo option dosseg 	  >> x3cs.lnk
	echo file $(L_OBJS) 	  >> x3cs.lnk
	echo file $(CONFIG)	  >> x3cs.lnk
	echo library $(L_COMMON)  >> x3cs.lnk
	echo library $(SVGA) 	  >> x3cs.lnk
	echo library $(L_NCSA)    >> x3cs.lnk

clean:	.SYMBOLIC
	rm -f *.err *.lst *.map *.exe *.obj *.bak *.lnk
